Attribute VB_Name = "Module3"
 Public Sub spline(ByRef x() As Double, ByRef y() As Double, poly_coef() As Double, ByRef condition As Integer, left_slope As Double, ByRef right_slope As Double)
   Dim i, N As Integer
   Dim s() As Double
   Dim s1() As Double
   Dim h() As Double
   Dim a() As Double
   Dim a1() As Double
   N = UBound(x) - 1
   ReDim s(N)
   ReDim h(N - 1)
   ReDim a(N - 2, 3)
   ReDim a1(N, 3)
   ReDim s1(N - 2)
   N = N
   For i = 0 To N - 1
      h(i) = x(i + 1) - x(i)
   Next i
   For i = 1 To N - 3
      a(i, 0) = h(i)
      a(i, 1) = 2 * (h(i) + h(i + 1))
      a(i, 2) = h(i + 1)
      a(i, 3) = 6 * ((y(i + 2) - y(i + 1)) / h(i + 1) - (y(i + 1) - y(i)) / h(i))
   Next i
     a(0, 3) = 6 * ((y(2) - y(1)) / h(1) - (y(1) - y(0)) / h(0))
     a(N - 2, 3) = 6 * ((y(N) - y(N - 1)) / h(N - 1) - (y(N - 1) - y(N - 2)) / h(N - 2))
     a(0, 0) = 0
     a(N - 2, 2) = 0

If condition = 1 Then
           a(0, 1) = 2 * (h(0) + h(1)):   a(0, 2) = h(1)
           a(N - 2, 0) = h(N - 2):   a(N - 2, 1) = 2 * (h(N - 2) + h(N - 1))
           s(0) = 0:   s(N) = 0
ElseIf condition = 3 Then
           a(0, 1) = 3 * h(0) + 2 * h(1):   a(0, 2) = h(1)
           a(N - 2, 0) = h(N - 2):     a(N - 2, 1) = 2 * h(N - 2) + 3 * h(N - 1)
ElseIf condition = 4 Then
           a(0, 1) = (h(0) + h(1)) * (h(0) + 2 * h(1)) / h(1)
           a(0, 2) = (h(1) ^ 2 - h(0) ^ 2) / h(1)
           a(N - 2, 0) = (h(N - 2) ^ 2 - h(N - 1) ^ 2) / h(N - 2)
           a(N - 2, 1) = (h(N - 1) + h(N - 2)) * (h(N - 1) + 2 * h(N - 2)) / h(N - 2)
End If
     Call thomas(a, s1)
For i = 0 To N - 2
    s(i + 1) = s1(i)
Next i
If condition = 3 Then
            s(0) = s(1):       s(N) = s(N - 1)
ElseIf condition = 4 Then
            s(0) = ((h(0) + h(1)) * s(1) - h(0) * s(2)) / h(1)
            s(N) = ((h(N - 2) + h(N - 1)) * s(N - 1) - h(N - 1) * s(N - 2)) / h(N - 2)
End If
For i = 0 To N - 1
    poly_coef(i, 0) = (s(i + 1) - s(i)) / (6 * h(i))
    poly_coef(i, 1) = s(i) / 2
    poly_coef(i, 2) = (y(i + 1) - y(i)) / h(i) - (2 * h(i) * s(i) + h(i) * s(i + 1)) / 6
    poly_coef(i, 3) = y(i)
Next i

End Sub

