Attribute VB_Name = "Module8"
Public Sub Bubble(composition() As Double, Temperature As Double, bubble_y() As Double, bubble_p As Double, eps As Double)
Dim i, j, N As Integer
Dim p_temp, ptemp1, sum_y, zl, zv, error1, sum_y_temp, sum_y_temp1, bubble_p1, hh As Double
Dim ki() As Double
Dim liq_fug() As Double
Dim vap_fug() As Double
   N = nnn - 1
   ReDim ki(N)
   ReDim liq_fug(N)
   ReDim vap_fug(N)
   N = nnn
   j = 0
   'for i=0 to N-1
   '  bubble_p=bubble_p+composition(i)*Pc(i)*exp(5.37*(1+w(i))*(1-Tc(i)/temperature))}
   For i = 0 To N - 1
       ki(i) = Pc(i) / bubble_p * Exp(5.37 * (1 + w(i)) * (1 - Tc(i) / Temperature))
       bubble_y(i) = ki(i) * composition(i)
   Next i
   p_temp = bubble_p
   sum_y_temp = sum(bubble_y)

   Call normalize(bubble_y)


   Call SRK(composition, bubble_p, Temperature, liq_fug, 1)
   Call SRK(bubble_y, bubble_p, Temperature, vap_fug, 2)
   For i = 0 To N - 1
       ki(i) = liq_fug(i) / vap_fug(i)
       bubble_y(i) = ki(i) * composition(i)
   Next i
   sum_y = sum(bubble_y)
   error1 = Abs(sum_y - 1)
   bubble_p = 1.05 * bubble_p
    Call normalize(bubble_y)
   While (error1 > eps)
     Call SRK(composition, bubble_p, Temperature, liq_fug, 1)
     Call SRK(bubble_y, bubble_p, Temperature, vap_fug, 2)
     For i = 0 To N - 1
         ki(i) = liq_fug(i) / vap_fug(i)
         bubble_y(i) = ki(i) * composition(i)
     Next i
     sum_y = sum(bubble_y)
     error1 = Abs(sum_y - 1)
     j = j + 1
     bubble_p1 = (1 - sum_y_temp) * (bubble_p - p_temp) / (sum_y - sum_y_temp) + p_temp
     p_temp = bubble_p
     bubble_p = bubble_p1
     sum_y_temp = sum_y
     Call normalize(bubble_y)
   Wend
End Sub

Public Sub Dew(composition() As Double, Temperature As Double, dew_x() As Double, dew_p As Double, eps As Double)
  Dim i, j, N As Integer
  Dim p_temp, ptemp1, sum_x, zl, zv, error1, sum_x_temp, dew_p1, hh As Double
  Dim ki() As Double
  Dim liq_fug() As Double
  Dim vap_fug() As Double
     N = nnn - 1
     ReDim ki(N)
     ReDim liq_fug(N)
     ReDim vap_fug(N)
     N = nnn
     dew_p = 0
     j = 0
     For i = 0 To N - 1
       dew_p = dew_p + composition(i) / (Pc(i) * Exp(5.37 * (1 + w(i)) * (1 - Tc(i) / Temperature)))
     Next i
     dew_p = 1 / dew_p
     For i = 0 To N - 1
         ki(i) = Pc(i) / dew_p * Exp(5.37 * (1 + w(i)) * (1 - Tc(i) / Temperature))
         dew_x(i) = composition(i) / ki(i)
     Next i
     p_temp = dew_p
     sum_x_temp = sum(dew_x)

     Call normalize(dew_x)


     Call SRK(dew_x, dew_p, Temperature, liq_fug, 1)
     Call SRK(composition, dew_p, Temperature, vap_fug, 2)
     For i = 0 To N - 1
         ki(i) = liq_fug(i) / vap_fug(i)
         dew_x(i) = composition(i) / ki(i)
     Next i
     sum_x = sum(dew_x)
     error1 = Abs(sum_x - 1)
     dew_p = 1.05 * dew_p
     Call normalize(dew_x)
   While (error1 > eps)
     Call SRK(dew_x, dew_p, Temperature, liq_fug, 1)
     Call SRK(composition, dew_p, Temperature, vap_fug, 2)
     For i = 0 To N - 1
         ki(i) = liq_fug(i) / vap_fug(i)
         dew_x(i) = composition(i) / ki(i)
     Next i
     sum_x = sum(dew_x)
     error1 = Abs(sum_x - 1)
     j = j + 1
     dew_p1 = (1 - sum_x_temp) * (dew_p - p_temp) / (sum_x - sum_x_temp) + p_temp
     p_temp = dew_p
     dew_p = dew_p1
     sum_x_temp = sum_x
     Call normalize(dew_x)
   Wend
End Sub

